; Arkanoid 980915
; James Rubingh  86guy@usa.net
; http://members.tripod.com/~jaymzroo
; http://www.eden.rutgers.edu/~assets/acz  -ACZ-
 
; Just a quick note. Since i was using the Graph_mem for grayscale I 
; didnt use a video buffer effect to stop flickering, so any flickering 
; was avoided but its still there.

; Also, i borrowed Patrick Davidsons PutSprite routine that can draw 32
; pixel wide sprites, thanks man. If you would prefer that i write my
; own i will. (i know its kinda rude to be asking this now)


 .include asm86.h
 .include ti86asm.inc   
 .include ti86un.inc    ;Dux Gregis made this file, get it from the ACZ
 .org _asm_exec_ram


data = $9000            ;level data 128 bytes, last data byte $9000+127
balla = $9000+128       ;ball data 1.0=up 1=down 2.scale 34.xy 5.Dead
score = _textShadow
lives = _textShadow+2
level = _textShadow+3
x = _textShadow+23
p = _textShadow+4       ;0 = normal nz=big ass paddle
PS_addy = _textShadow+5
ballz = _textShadow+7
temp = _textShadow+8
tempy = _textShadow+9
delay = _textShadow+10
blocks = _textShadow+11
b = _textShadow+18
much = _textShadow+19   ;how many hits since the ball last hit the paddle
dead = _textShadow+20
end = _textShadow+21
switch = _textShadow+22
FP_RLD = _textShadow+24
bonus = _textShadow+25
bonusHL = _textShadow+26

 nop
 jp start
 .dw 0
 .dw Title
start:
  
;----- estoy iniciando -----
  call $49DC
  call _runindicoff
  
  call _clrLCD
  ld hl,$0202
  ld (_curRow),hl
  ld hl,TITLE
  call _puts
  ld hl,$0207
  ld (_curRow),hl
  ld hl,Author
  call _puts
loop:
  call GET_KEY
  cp K_ENTER
  jr nz,loop
  
  ld hl,_textShadow
  xor a
  ld de,_textShadow+1
  ld bc,168
  ld (hl),a
  ldir
  ld de,$9001
  ld hl,$9000
  ld bc,$500
  xor a
  ld (hl),a
  ldir                  ;clear the array table data 

 call _clrLCD
 call cbuffer           ;clears the second buffer for grayscale shit
                        ;which starts 6 bytes after the Graph Memory did
  
  res 1,(iy+$0d)        ; shit, i need a beer
  ld a,1
  ld (level),a
  add a,3
  ld (lives),a

  call OpenGray         ;turn on the grayscale
  call unpacklevel      ;decompress the level to the data area
  call initiatelevel
  call DrawLine         ;draws the horizontal line above the blocks
  call drawblox         ;draw all of the initial blox onto the screen
  call show_score

main:
  ld a,%00111110        ;keypress mask
  out (1),a             ;keypad port
  in a,(1)
  bit 4,a
  jp z,teacher          ;jump to quick quit
  bit 7,a
  call z,enter_pause    ;pause till 2nd is pushed
  bit 6,a               ;test for key exit
  jp z,exit_key
  bit 2,a               ;test for key right
  ld c,a                ;preserve the keypress results in A
  call z,p_right
  ld a,c                ;restore the results from the keyport 
  bit 1,a               ;test for key left
  call z,p_left

  call dpaddle
  call ProcessBallz
  
  call drawblox
  call PutBall          ;clear the old one, draw the new one
  
  ld a,(dead)
  cp 1
  call z,died
  
  jr main

p_right:
 ld a,(x)
 inc a                  ;this command increases the A register
 inc a
 ld b,a
 ld a,(p)
 or a
 ld a,b
 jr z,short
 cp 95
 ret nc
 jp good
short:
 cp 113
 ret nc 
good:
 ld b,a
 ld a,c
 bit 3,a
 jr nz,noup
 dec b
noup: 
 ld a,b
 ld (x),a
 call clear_old         ;clear away the old paddle
 ret

p_left:
 ld a,(x)
 cp 2
 ret c
 dec a
 dec a
 ld b,a
 ld a,c                 ;the keypress mask
 bit 3,a
 jr nz,noleft
 inc b
noleft: 
 ld a,b
 ld (x),a
 call clear_old
 ret 

PutBall:
 ld hl,$cc80
 ld de,$cc81
 xor a
 ld (hl),a
 ld bc,320-1
 ldir                   ;clear the NO-MANS-LAND
 ld hl,$fe80
 ld de,$fe81
 xor a
 ld (hl),a
 ld bc,320-1
 ldir                   ;clear the NO-MANS-LAND
 
 ld de,$fc00            ;oh yea, this is stupid 
 call ball_draw_stuff   ;its not a grayscale routine so I have 
 ld de,$ca00            ;to draw it twice to each of the
 call ball_draw_stuff   ;bitmapped areas, the putsprite routine
 ret                    ;does the same thing with drawing twice

ball_draw_stuff:        ;This draws a 3x3 block of ON pixels non-alligned
 ld hl,balla+2
 ld b,(hl)
 inc hl
 ld c,(hl)
 dec b
 call Find_Pixel
 add hl,de
 ld d,a
 ld c,3
PB_col: 
 push af
 push hl
 ld b,3
PB_row: 
 ld e,a
 or (hl)
 ld (hl),a
 ld a,e
 rrca                   ;rotate right with branch carry
 jr nc,SB
  inc hl                ;No carry? then dont change bytes
SB:
 djnz PB_row
 pop hl
 ld a,16
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 pop af
 dec c
 jr nz,PB_col
 ret

;PutPixel:
; call Find_Pixel
; ld de,(PS_addy)
; add hl,de
; or (hl)
; ld (hl),a
; ret

dpaddle:
 ld a,(p)
 or a
 jr z,shortpaddle
 ld hl,x
 ld d,(hl)
 ld ix,paddle
 ld hl,$fc00
 ld (PS_addy),hl
 ld e,60
 push de
 call drw_sprw
 ld hl,$ca00
 ld (PS_addy),hl
 ld ix,paddle2
 pop de
 call drw_sprw
 ret

shortpaddle: 
 ld hl,x
 ld d,(hl)
 ld ix,paddle
 ld hl,$fc00
 ld (PS_addy),hl
 ld e,60
 push de
 call drw_sprw
 ld hl,$ca00
 ld (PS_addy),hl
 ld ix,paddle2
 pop de
 call drw_sprw
 ret

clear_old:
 push bc
 ld hl,$ca00+(16*60)
 ld de,$ca00+(16*60)+1
 xor a
 ld (hl),a
 ld bc,64
 ldir
 ld hl,$fc00+(16*60)
 ld de,$fc00+(16*60)+1
 xor a
 ld (hl),a
 ld bc,64
 ldir
 pop bc
 ret

DrawLine:
 ld hl,$fc70            ;draw a single horizontal line, 7 down
 ld b,16
 ld a,255
DL_LOOP:
 ld (hl),a
 inc hl
 djnz DL_LOOP
 ret

ProcessBallz:           ; UP/DO    SC     X    Y
  ld a,(switch)
  xor 1
  ld (switch),a
  
  
  ld ix,balla
  call ball_test
  call paddle_test
  call test_death
  
  ld ix,balla+4
  xor a
setup_dead:             ;sets up the dead flag
  add a,(ix)
 ; add a,(ix+5)         ;for when there are three ballz
 ; add a,(ix+10)
  ld (dead),a
  ret

ball_test:  
  ld a,(ix+4)
  cp 1
  ret z
  
  ld a,(ix)             ;UP/DO
  ld b,(ix+2)           ;X
  ld c,(ix+3)           ;Y

test_vertical:
  add a,c
  sub 7
  ld c,a
  or a
  jr z,not_clear_up
  call get_block_type
  or a
  jr z,its_clear_v      ;it was clear vertically


not_clear_up:  
  call maybe_clear_brick
  
  ld a,(ix)             ;it wasnt clear vertically
  neg 
  ld (ix),a
  
  jr test_horizontal
its_clear_v:
  ld a,(ix)
  add a,(ix+3)
  ld (ix+3),a
  ;jp test_horizontal

test_horizontal:
  ld a,(ix+1)
  ld b,(ix+2)          ;X  
  ld c,(ix+3)

  cp 0
  jr z,fine_scale
  jp p,movingright
  inc a
  or a
  jr nz,fine_scale
  ld a,(switch)
  dec a
  jp fine_scale

movingright:
  dec a
  or a
  jr nz,fine_scale
  ld a,(switch)

fine_scale:  
  ld (temp),a
  add a,b
  cp 127
  jr nc,switch_horiz  
  cp 1
  jp m,switch_horiz

  ld a,(ix+3)
  ld a,c
  sub 7
  ld c,a
  ld a,(temp)
  add a,(ix+2)
  ld b,a
  call get_block_type
  or a
  jr nz,switch_horiz
  
  ld a,(temp)           ;X
  add a,(ix+2)          ;scale
  ld (ix+2),a           ;X+scale
  ret

switch_horiz:
  ld a,(ix+1)
  neg
  ld (ix+1),a
  
  ld a,(hl)             ;if its cleared, then dont clear brick
  or a          
  ret z

  call maybe_clear_brick
  ret                   ;dont change this to jp cause it might not finish
                        ;It will screw up the ret command if you do
maybe_clear_brick:      
  cp 3                  ;check if its a solid
  ret z
  
  dec a                 ;this is still the value from 'maybe_c...'
  ld (hl),a
  ret nz                ;if the block didnt dissapear, then dont decrease the
  ld hl,(score)
  ld a,(much)
  add a,a               ;much*8
  add a,a
  add a,a
  add a,50
  add a,l
  ld l,a
  adc a,h               ;add HL+A
  sub l
  ld h,a
  ld (score),hl
  call show_score
  
  ld hl,much
  inc (hl)
  
  ld a,(blocks)         ;counter that says how many blocks to go.
  dec a
  or a
  jr z,newlevel
  ld (blocks),a
  ret

newlevel:
  ld a,(level)
  inc a
  cp 9
  jp z,finished
  ld (level),a
  call unpacklevel      ;you dont want to unpack at death
notdead:  
  call initiatelevel
  call clear_old
  call drawblox
  call PutBall
  call DrawLine
  call dpaddle
  call show_score
  pop hl                ;maybe..   
  pop hl                ;ball_test
  jp enter_pause
  
get_block_type:
  ld a,c
  cp 32
  jp nc,off_array
  srl c
  srl c
  ld l,c
  ld h,0
  add hl,hl
  add hl,hl
  add hl,hl
  add hl,hl
  srl b
  srl b
  srl b
  ld e,b
  ld d,0
  add hl,de
  ld de,data
  add hl,de
  ld a,(hl)
  ret
off_array:
 xor a
 ret

enter_pause:
 ld hl,e_pause
 ld de,$3031
 ld (_penCol),de
 call _vputs
e_p:
 halt
 ld a,%00111111
 out (1),A
 nop 
 nop
 in a,(1)
 bit 5,a
 jr nz,e_p
 ret

paddle_test:
 ld a,(ix+3)
 cp 59
 jr z,pt_1
 cp 60
 jr z,pt_1
 cp 61
 jr z,pt_1
 ret                    ;if its not at the paddle's height, dont do this
pt_1:

 ld a,(p)
 or a
 jr nz,big_ass_paddle
normal_paddle:
 ld hl,x                ;paddles X location
 ld a,(hl)
 ld b,(ix+2)            ;ballz X position
 cp b
 ret nc
 add a,15
 cp b
 ret c                  ;make sure the ball is somewhere over the paddle
 sub 15
 ld c,a                 ;switch A&B using C
 ld a,b
 ld b,c
 sub b                  ;find the difference, put that in 'A' register
 add a,a
 ld hl,move_table
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld a,(hl)
 ld (ix+1),a
 ld a,-1
 ld (ix),a
 call clear_old
 xor a
 ld (much),a
 ret

big_ass_paddle: 
 ld hl,x                ;paddles X location
 ld a,(hl)
 ld b,(ix+2)            ;ballz X position
 cp b
 ret nc
 add a,32
 cp b
 ret c                  ;make sure the ball is somewhere over the paddle
 sub 32
 ld c,a                 ;switch A&B using C
 ld a,b
 ld b,c
 sub b                  ;find the difference, put that in 'A' register
 ld hl,move_table
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld a,(hl)
 ld (ix+1),a
 ld a,-1
 ld (ix),a
 call clear_old
 xor a
 ld (much),a
 ret

test_death
 ld a,(ix+3)
 cp 63
 ret nz
                        ;ball is too low, so it is dead
 ld a,1
 ld (ix+4),a
 ret


unpacklevel:
  ld a,(savedgame)
  or a
  jr z,normal_start
  
  ld hl,savedscore
  ld de,_textShadow
  ld bc,4
  ldir
  ld hl,savedgame
  xor a
  ld (hl),a
  inc hl
  jr saved_start
normal_start:  
  ld a,(level)          ;what level are you on?
  ld b,a
  ld hl,leveldata-32    ;all the compressed level data
  ld de,32
getaddy:
  add hl,de             ;add 32 for every level youre on
  djnz getaddy
  
saved_start:
  ld b,32               ;Copy the map + count blocks
  ld de,data
set_up_1:
  ld c,(hl)
  rlc c
  rlc c
  ld a,c
  and 3
  ld (de),a
  inc de
  rlc c
  rlc c
  ld a,c
  and 3
  ld (de),a
  inc de
  rlc c
  rlc c
  ld a,c
  and 3
  ld (de),a
  inc de
  rlc c
  rlc c
  ld a,c
  and 3
  ld (de),a
  inc de
  inc hl
  djnz set_up_1

count_blocks:
  ld hl,blocks
  xor a
  ld (hl),a
  ld de,data
  ld b,128
count_loop:
  ld a,(de)
  dec a
  jr z,increase_blocks
  dec a
  jr nz,skip_increase
increase_blocks:
  inc (hl)
skip_increase:
  inc de
  djnz count_loop
  ret

drawblox:
 ld b,128
 xor a
bloxloop
 ld c,a
 push bc
 call DrawA
 pop bc                 ;dont wanna mess up the counter
 ld a,c
 inc a
 djnz bloxloop
 ret

DrawA:
 ld b,a                 ;type
 rrca
 rrca
 rrca
 rrca
 and %00001111
 ld l,0                 ;\
 rra
 rr l                   ;   \
 rra                    ;   / Multiply A by 64, and store into HL Quickly
 rr l           
 ld h,a                 ;/
 ld a,b
 and 15                 ;add hl,A
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld a,128
 add a,l
 ld l,a
 adc a,h
 sub l
 ld h,a
 ld e,b                 ;add data,block number
 ld d,0
 ld bc,data
 ex de,hl
 add hl,bc
 ex de,hl
 ld a,(de)
 or a
 jp z,zero_
 dec a 
 jr z,one_
 dec a
 jr z,two_
 
 jr three_
zero_:
 ld de,16
 ld bc,$ca00
 push hl
 add hl,bc
 xor a
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 pop hl
 ld a,h
 or $FC
 ld h,a
 ;add hl,bc
 xor a
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 ret

two_
 ld de,16
 ld bc,$ca00
 push hl
 add hl,bc
 ld a,255
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 pop hl
 
 ld a,h
 or $FC
 ld h,a
 ;ld bc,$FC00
 ;add hl,bc
 
 ld a,255
 ld (hl),a
 add hl,de
 ld a,%11000011
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld a,255
 ld (hl),a
 ret

one_
 ld de,16
 ld bc,$ca00
 push hl
 add hl,bc
 ld a,%11111110
 ld (hl),a
 add hl,de
 ld a,%10000000
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 xor a
 ld (hl),a
 pop hl
 
 ld a,h
 or $FC
 ld h,a
 ;ld bc,$FC00
 ;add hl,bc
 
 ld a,%00000001
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld a,$ff
 ld (hl),a
 ret

three_
 ld de,16
 ld bc,$ca00
 push hl
 add hl,bc
 ld a,255
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 pop hl
 
 ld a,h
 or $FC
 ld h,a
 ;ld bc,$FC00
 ;add hl,bc
 ld a,$FF
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 add hl,de
 ld (hl),a
 ret

initiatelevel:
;set up some initial variables
  ld a,55
  ld (x),a
  ld hl,$fc00
  ld (PS_addy),hl
  ld a,1
  ld (ballz),a          ;how many balls??
  
  ld a,-1               ;this shit will set up the first freakin ball
  ld hl,balla
  ld (hl),a             ;load into UP/DOWN 0
  inc hl
  ld a,1                ;scale
  ld (hl),a
  ld a,65
  inc hl                ;load into X 65
  ld (hl),a
  ld a,58
  inc hl                ;load into Y 58
  ld (hl),a
  
show_lives:
  ld hl,$0035
  ld (_penCol),hl
  ld de,lnumber+1
  ld a,(lives)
  ld l,a
  ld h,0
  ld b,2
shw_l:
  call UNPACK_HL
  add a,'0'
  ld (de),a
  dec de
  djnz shw_l
  ld hl,msglives
  jp _vputs

show_score:  ld hl,0
  ld (_penCol),hl
  ld hl,(score)
  ;jp d_zm_deci        ;display the score real quick

D_zm_deci:              ;remember to set (penCol) and (penRow)
d_zm_deci: 
 ld de,number+4
 ld b,5
zm_hl:
 call UNPACK_HL
 add a,'0'
 ld (de),a
 dec de
 djnz zm_hl
 ld hl,current_score
 call _vputs
 ret

cbuffer:
  xor a
  ld hl,$ca00           
  ld de,$ca01
  ld (hl),a
  ld bc,$400-1
  ldir
  ret

; uh.. nobody look at this. I got it from Patrick Davidson, it draws
;   sprites to the screen that are possibly bigger than 8 pixels

drw_sprw:ld       a,d   ;ix = bitmap de=coordinates
         and      7
         ld       hl,offsets_table
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       a,(hl)
         ld       (wsmc1+1),a
         ld       (wsmc2+1),a
       
         ld       hl,(PS_addy)    ;    Calculate byte number
         ld       B,0
         ld       a,e
         add      a,a
         add      a,a
         add      a,a
         rl       b
         add      a,a
         rl       b
         ld       c,d
         srl      c
         srl      c
         srl      c
         or       c
         ld       c,a
         add      hl,bc                                    
          
         ld       d,(ix)       
         ld       b,(ix+1)        
woloop:  push     bc                ;Save # of rows
         push     hl                ;Save screen address
         ld       b,d               ;Load width
         ld       c,(ix+2)          ;Load one line of image
         inc      ix
wsmc1    ld       a,1               ;Load pixel mask
wiloop:  sla      c                 ;Test leftmost pixel
         jr       nc,wnoplot         ;See if a plot is needed
         ld       e,a               ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
   jp wcarryon
wnoplot: 
   ld e,a            ;this was added by myself, really quick
   cpl              ;so that it wouldnt just "add" the sprite
   and (hl)          ;to the screen but also delete any pixels
   ld (hl),a        ;that were supposed to be cleared by the sprite
   ld a,e               
wcarryon:         
         rrca
         jr       nc,wnotedge        ;Test if edge of byte reached
         inc      hl                ;Go to next byte
wnotedge
wsmc2:   cp       1
         jr       z,wover_1

         djnz     wiloop
         pop      hl                ;Restore address
         ld       bc,16             ;Go to next line
         add      hl,bc
         pop      bc                ;Restore data
         djnz     woloop
         ret
wover_1: ld       c,(ix+2)
         inc      ix
         djnz     wiloop
         dec      ix
         pop      hl
         ld       bc,16
         add      hl,bc
         pop      bc
         djnz     woloop
         ret

offsets_table: .db 128,64,32,16,8,4,2,1

Find_Pixel:             ;This is an edited EBLE-YOPP routine
  push bc
  push de               ;faster than the eble yopp routine! by 04 t-states       
  
  ld de,offsets_table
  ld a,b                 
  and %00000111          
  add a,e                        
  ld e,a                ; Apply changes to L
  adc a,d               ; Adds the carry flag. 
  sub e                 ; Subtracts L
  ld d,a                ; Apply changes to H
                      
  ld hl,FP_RLD          ; HL points to FP_RLD
  ld (hl),c             ; FP_RLD = Y
  ld a,b                ; A = X
  rra                   ; /2
  rra                   
  rra                   ; /8
  rld                   
  and %00000011   
  ld l,(hl)                             
  ld h,a           
  ld a,(de)       
  pop de
  pop bc
  ret                   ; holy ... that was fast..

finished:
  call CloseGray
  ;ei            
  ld hl,$0102
  ld (_curRow),hl
  ld hl,sFinal
  call _puts
fin_pause:
  call GET_KEY
  cp K_ENTER
  jr nz,fin_pause
  
  pop hl                        ;the other day i was at the skate park...
  pop hl
  jr exit_dead
died:
  ld a,(lives)
  dec a
  cp 0
  jr z,exit_dead
  ld (lives),a
  xor a
  ld hl,balla+4
  ld (hl),a
  push hl 
  push hl
  jp notdead
exit_dead:
   pop hl
exit_key:  
  call CloseGray        
  ei                    ;this seems to effect the ending sequence
  xor a
  ld (savedgame),a
  ld hl,(highscore)
  ld de,(score)
  or a
  sbc hl,de
  jr nc,leave                ;exit the game completely
  ld hl,(score)
  call d_zm_deci
  ld de,High_menu
  ld hl,number
  ld bc,5
  ldir
  ld hl,(score)
  ld (highscore),hl
leave:
  ld hl,progname-1
  rst 20h
  rst 10h
  ex de,hl              ;set up AHL results of FIND_SYM
  ld a,b
  ld de,highscore-_asm_exec_ram+4
  add hl,de             ;add AHL,DE
  adc a,0
  ld de,highscore
  ld b,24               ;bytes to store this also overwrites the saved flag
  call RepCopy
  
 ;----CLEAN UP----
  set 1,(iy+$0d)
  call _clrScrn
  ;call _clrLCD
  call cbuffer
backtotheshellassemblygame ;go back to the shell you crazy game  
  call GET_KEY
  ret

RepCopy:
  push af
  push hl
  call $46C3            ; if you must know... this turns AHL into asic
  ld a,(de)             ; There exist another RomCall that is specifically
  ld (hl),a             ; for converting ABS pointers to ASIC, but i didnt
  pop hl                ; feel like finding it, cause i really dont care :)
  pop af
  call $4637
  inc de
  djnz RepCopy
  ret                                                                     

teacher:
  call CloseGray
  ei
  ld hl,savedgame
  ld a,1
  ld (hl),a
  inc hl
  ld de,data
  ld b,32
compress:
  push bc
  ld c,0
  ld b,4
compress2:
  rlc c
  rlc c
  ld a,(de)
  or c
  ld c,a
  inc de
  djnz compress2
  ld (hl),c
  inc hl
  pop bc
  djnz compress
  ex de,hl
  ld hl,_textShadow
  ld bc,4
   ldir
  ld hl,progname-1
  rst 20h
  rst 10h
  ex de,hl              ;set up AHL results of FIND_SYM
  ld a,b
  ld de,savedgame-_asm_exec_ram+4
  add hl,de             ;add AHL,DE
  adc a,0
  ld de,savedgame
  ld b,37               ; bytes to store
  call RepCopy          ;copy bytes from de to AHL until B=0

  set 1,(iy+$0d)
  call _clrScrn
  call cbuffer
  call $4a95
  jp _jforce

leveldata           ;there are eight 

  .db %00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000
  .db %00010101,%01010101,%01010101,%01010100
  .db %00010101,%01010101,%01010101,%01010100
  .db %00000000,%00000000,%00000000,%00000000
  .db %00001010,%00000010,%10000000,%10100000
  .db %00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000
  
  .db %00000000,%00000000,%00000000,%00000000
  .db %00010001,%00010001,%00010001,%00010001
  .db %01000100,%01000100,%01000100,%01000100
  .db %00010001,%00010001,%00010001,%00010001
  .db %01000100,%01000100,%01000100,%01000100
  .db %00010001,%00010001,%00010001,%00010001
  .db %00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000

  .db %11110000,%00000000,%00000000,%00001111
  .db %11000101,%01000000,%00000001,%01010011
  .db %00000101,%01000101,%01010001,%01010000
  .db %00000101,%01000111,%11010001,%01010000
  .db %00000101,%01000111,%11010001,%01010000
  .db %00000000,%00000101,%01010000,%00000000
  .db %00000000,%00000000,%00000000,%00000000
  .db %00000000,%00000000,%00000000,%00000000
  
  .db %01010101,%00101001,%01010001,%01010100
  .db %01010101,%00101001,%00010001,%00000100
  .db %00010100,%00101001,%00010001,%00000000
  .db %00010100,%00101001,%11010001,%01010100
  .db %00010100,%00101001,%00010001,%00000100  ;ti86
  .db %00010100,%00101001,%00010001,%00000100
  .db %00010100,%00101001,%00010001,%00000100
  .db %00010100,%00101001,%01010001,%01010100

  .db %11111101,%00000000,%00000000,%01111111
  .db %11110101,%00000000,%00000000,%00011111
  .db %11010000,%00000001,%01000000,%00000111
  .db %00000000,%00010100,%00010100,%00000000
  .db %00000000,%01000000,%00000001,%00000000
  .db %00000000,%01000000,%00000001,%00000000
  .db %00000000,%00010100,%00010100,%00000000
  .db %00000000,%00000001,%01000000,%00000000

  .db %01010100,%11110000,%00001111,%00010101
  .db %01010100,%11000000,%00000011,%00010101
  .db %01010100,%11000000,%00000011,%00010101
  .db %01010100,%00000000,%00000000,%00010101
  .db %01010100,%00000000,%00000000,%00010101
  .db %01010100,%00000000,%00000000,%00010101
  .db %01010100,%00000000,%00000000,%00010101
  .db %11111111,%11000000,%00000011,%11111111
                              
  .db %01000000,%11110001,%01000000,%01010000
  .db %01000000,%11110001,%01000000,%01010000
  .db %01000100,%00000001,%01000000,%01010000
  .db %01010000,%01010001,%01000000,%01010000
  .db %01010000,%01010001,%01000000,%01010000
  .db %01000100,%01010001,%01000000,%01010000
  .db %01000100,%01010001,%01010100,%01010101
  .db %01000000,%01010001,%01010100,%01010101

  .db %01010101,%00000000,%00000001,%01010000
  .db %01010101,%00010100,%00000001,%01010100
  .db %01000000,%00010101,%01000001,%00000101
  .db %01000000,%00010100,%01000001,%00000101
  .db %01010100,%00010100,%01000001,%00000101
  .db %01000000,%00010100,%01000001,%00000101
  .db %01010101,%00010100,%01000001,%01010100
  .db %01010101,%00010100,%01000001,%01010000

paddle
  .db 16,4
  .db %01111111,%11111110               ;bitmap for normal paddle
  .db %11000000,%00000011               ;kinda dark
  .db %11111111,%11111111               ;kinda dark
  .db %01111111,%11111110
paddle2
  .db 16,4
  .db %01111111,%11111110               ;really light
  .db %10111111,%11111101
  .db %10000000,%00000001
  .db %01111111,%11111110


move_table:             ;32 different because the big paddle is 32 wide
 .db      -3,-3
 .db      -2,-2,-2,-2,-2,-2
 .db      -1,-1,-1,-1,-1,-1
 .db      -1,-1,0,0                     ;dont ask
 .db      1,1,1,1,1,1
 .db      2,2,2,2,2,2
 .db      3,3


Author          .db "by: James Rubingh",0
progname        .db 8,"Arkanoid"             ;for the addressing 
current_score:  .db "Score: "
number:         .db 0,0,0,0,0,0          ;for putting numbers on screen
msglives:          .db "Lives: "            
lnumber:        .db 0,0,0                ;Only double digits, then a null
e_pause:        .db "Press 2nd",0
sFinal:         .db "Congratulations You     "
                .db "Beat The Game",0
TITLE:          .db "Arkanoid Beta v.9",0

;-----Stuff that stays the same when you exit
highscore:      .dw 0                 
highname:       .db "JIM"
Title           .db "High Score: "
High_menu:      .db "00000",0
savedgame:      .db 0                    ;saved game data

  .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
  .db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

savedscore:     .dw 420             ;also the saved lives, level
                .db 0,0
.include gray.h                 ;grayscale IM 2 routines by Dux Gregis

;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
;    James Rubingh  86guy@usa.net
; http://members.tripod.com/~jaymzroo
; UIN:159   AOL_SN:power2ezln
;  ACZ member -Assembly Coders Zenith-
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
 .end
